/* Include files */

#include "blascompat32.h"
#include "HC2_SummerSchool_sfun.h"
#include "c8_HC2_SummerSchool.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "HC2_SummerSchool_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c8_debug_family_names[16] = { "relax", "workload", "LRelax",
  "LWorkload", "LEMG", "nargin", "nargout", "Alpha1", "Alpha2", "Alpha3",
  "AlphaThres", "ThetaFz", "AlphaFz", "WorkloadThres", "EMG", "ThresEMG" };

/* Function Declarations */
static void initialize_c8_HC2_SummerSchool(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance);
static void initialize_params_c8_HC2_SummerSchool
  (SFc8_HC2_SummerSchoolInstanceStruct *chartInstance);
static void enable_c8_HC2_SummerSchool(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance);
static void disable_c8_HC2_SummerSchool(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance);
static void c8_update_debugger_state_c8_HC2_SummerSchool
  (SFc8_HC2_SummerSchoolInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c8_HC2_SummerSchool
  (SFc8_HC2_SummerSchoolInstanceStruct *chartInstance);
static void set_sim_state_c8_HC2_SummerSchool
  (SFc8_HC2_SummerSchoolInstanceStruct *chartInstance, const mxArray *c8_st);
static void finalize_c8_HC2_SummerSchool(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance);
static void sf_c8_HC2_SummerSchool(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance);
static void c8_chartstep_c8_HC2_SummerSchool(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance);
static void initSimStructsc8_HC2_SummerSchool
  (SFc8_HC2_SummerSchoolInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c8_machineNumber, uint32_T
  c8_chartNumber);
static const mxArray *c8_sf_marshallOut(void *chartInstanceVoid, void *c8_inData);
static real_T c8_emlrt_marshallIn(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void c8_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_b_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static int32_T c8_b_emlrt_marshallIn(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void c8_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static uint8_T c8_c_emlrt_marshallIn(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance, const mxArray *c8_b_is_active_c8_HC2_SummerSchool, const
  char_T *c8_identifier);
static uint8_T c8_d_emlrt_marshallIn(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void init_dsm_address_info(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c8_HC2_SummerSchool(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance)
{
  chartInstance->c8_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c8_is_active_c8_HC2_SummerSchool = 0U;
}

static void initialize_params_c8_HC2_SummerSchool
  (SFc8_HC2_SummerSchoolInstanceStruct *chartInstance)
{
}

static void enable_c8_HC2_SummerSchool(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c8_HC2_SummerSchool(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c8_update_debugger_state_c8_HC2_SummerSchool
  (SFc8_HC2_SummerSchoolInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c8_HC2_SummerSchool
  (SFc8_HC2_SummerSchoolInstanceStruct *chartInstance)
{
  const mxArray *c8_st;
  const mxArray *c8_y = NULL;
  uint8_T c8_hoistedGlobal;
  uint8_T c8_u;
  const mxArray *c8_b_y = NULL;
  c8_st = NULL;
  c8_st = NULL;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_createcellarray(1), FALSE);
  c8_hoistedGlobal = chartInstance->c8_is_active_c8_HC2_SummerSchool;
  c8_u = c8_hoistedGlobal;
  c8_b_y = NULL;
  sf_mex_assign(&c8_b_y, sf_mex_create("y", &c8_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c8_y, 0, c8_b_y);
  sf_mex_assign(&c8_st, c8_y, FALSE);
  return c8_st;
}

static void set_sim_state_c8_HC2_SummerSchool
  (SFc8_HC2_SummerSchoolInstanceStruct *chartInstance, const mxArray *c8_st)
{
  const mxArray *c8_u;
  chartInstance->c8_doneDoubleBufferReInit = TRUE;
  c8_u = sf_mex_dup(c8_st);
  chartInstance->c8_is_active_c8_HC2_SummerSchool = c8_c_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 0)),
     "is_active_c8_HC2_SummerSchool");
  sf_mex_destroy(&c8_u);
  c8_update_debugger_state_c8_HC2_SummerSchool(chartInstance);
  sf_mex_destroy(&c8_st);
}

static void finalize_c8_HC2_SummerSchool(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance)
{
}

static void sf_c8_HC2_SummerSchool(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance)
{
  real_T *c8_Alpha1;
  real_T *c8_Alpha2;
  real_T *c8_Alpha3;
  real_T *c8_AlphaThres;
  real_T *c8_ThetaFz;
  real_T *c8_AlphaFz;
  real_T *c8_WorkloadThres;
  real_T *c8_EMG;
  real_T *c8_ThresEMG;
  c8_ThresEMG = (real_T *)ssGetInputPortSignal(chartInstance->S, 8);
  c8_EMG = (real_T *)ssGetInputPortSignal(chartInstance->S, 7);
  c8_WorkloadThres = (real_T *)ssGetInputPortSignal(chartInstance->S, 6);
  c8_AlphaFz = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
  c8_ThetaFz = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c8_AlphaThres = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c8_Alpha3 = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c8_Alpha2 = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c8_Alpha1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 5U, chartInstance->c8_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c8_Alpha1, 0U);
  _SFD_DATA_RANGE_CHECK(*c8_Alpha2, 1U);
  _SFD_DATA_RANGE_CHECK(*c8_Alpha3, 2U);
  _SFD_DATA_RANGE_CHECK(*c8_AlphaThres, 3U);
  _SFD_DATA_RANGE_CHECK(*c8_ThetaFz, 4U);
  _SFD_DATA_RANGE_CHECK(*c8_AlphaFz, 5U);
  _SFD_DATA_RANGE_CHECK(*c8_WorkloadThres, 6U);
  _SFD_DATA_RANGE_CHECK(*c8_EMG, 7U);
  _SFD_DATA_RANGE_CHECK(*c8_ThresEMG, 8U);
  chartInstance->c8_sfEvent = CALL_EVENT;
  c8_chartstep_c8_HC2_SummerSchool(chartInstance);
  sf_debug_check_for_state_inconsistency(_HC2_SummerSchoolMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c8_chartstep_c8_HC2_SummerSchool(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance)
{
  real_T c8_hoistedGlobal;
  real_T c8_b_hoistedGlobal;
  real_T c8_c_hoistedGlobal;
  real_T c8_d_hoistedGlobal;
  real_T c8_e_hoistedGlobal;
  real_T c8_f_hoistedGlobal;
  real_T c8_g_hoistedGlobal;
  real_T c8_h_hoistedGlobal;
  real_T c8_i_hoistedGlobal;
  real_T c8_Alpha1;
  real_T c8_Alpha2;
  real_T c8_Alpha3;
  real_T c8_AlphaThres;
  real_T c8_ThetaFz;
  real_T c8_AlphaFz;
  real_T c8_WorkloadThres;
  real_T c8_EMG;
  real_T c8_ThresEMG;
  uint32_T c8_debug_family_var_map[16];
  real_T c8_relax;
  real_T c8_workload;
  real_T c8_LRelax;
  real_T c8_LWorkload;
  real_T c8_LEMG;
  real_T c8_nargin = 9.0;
  real_T c8_nargout = 0.0;
  real_T c8_u;
  const mxArray *c8_y = NULL;
  real_T c8_b_u;
  const mxArray *c8_b_y = NULL;
  real_T c8_c_u;
  const mxArray *c8_c_y = NULL;
  real_T c8_d_u;
  const mxArray *c8_d_y = NULL;
  char_T c8_e_u;
  const mxArray *c8_e_y = NULL;
  int32_T c8_i0;
  static char_T c8_cv0[2] = { 'o', 'n' };

  char_T c8_f_u[2];
  const mxArray *c8_f_y = NULL;
  int32_T c8_i1;
  real_T c8_g_u[2];
  const mxArray *c8_g_y = NULL;
  real_T c8_h_u[2];
  const mxArray *c8_h_y = NULL;
  char_T c8_i_u;
  const mxArray *c8_i_y = NULL;
  real_T c8_b;
  real_T c8_j_y;
  real_T c8_j_u[2];
  const mxArray *c8_k_y = NULL;
  int32_T c8_i2;
  static char_T c8_cv1[3] = { 'o', 'f', 'f' };

  char_T c8_k_u[3];
  const mxArray *c8_l_y = NULL;
  int32_T c8_i3;
  static char_T c8_cv2[10] = { 'R', 'e', 'l', 'a', 'x', 'a', 't', 'i', 'o', 'n'
  };

  char_T c8_l_u[10];
  const mxArray *c8_m_y = NULL;
  int32_T c8_i4;
  static char_T c8_cv3[8] = { 'f', 'o', 'n', 't', 's', 'i', 'z', 'e' };

  char_T c8_m_u[8];
  const mxArray *c8_n_y = NULL;
  real_T c8_n_u;
  const mxArray *c8_o_y = NULL;
  real_T c8_A;
  real_T c8_B;
  real_T c8_x;
  real_T c8_p_y;
  real_T c8_b_x;
  real_T c8_q_y;
  real_T c8_o_u;
  const mxArray *c8_r_y = NULL;
  real_T c8_p_u;
  const mxArray *c8_s_y = NULL;
  real_T c8_q_u;
  const mxArray *c8_t_y = NULL;
  real_T c8_r_u;
  const mxArray *c8_u_y = NULL;
  char_T c8_s_u;
  const mxArray *c8_v_y = NULL;
  int32_T c8_i5;
  char_T c8_t_u[2];
  const mxArray *c8_w_y = NULL;
  int32_T c8_i6;
  real_T c8_u_u[2];
  const mxArray *c8_x_y = NULL;
  real_T c8_v_u[2];
  const mxArray *c8_y_y = NULL;
  char_T c8_w_u;
  const mxArray *c8_ab_y = NULL;
  real_T c8_b_b;
  real_T c8_bb_y;
  real_T c8_x_u[2];
  const mxArray *c8_cb_y = NULL;
  int32_T c8_i7;
  char_T c8_y_u[3];
  const mxArray *c8_db_y = NULL;
  int32_T c8_i8;
  static char_T c8_cv4[8] = { 'w', 'o', 'r', 'k', 'l', 'o', 'a', 'd' };

  char_T c8_ab_u[8];
  const mxArray *c8_eb_y = NULL;
  int32_T c8_i9;
  char_T c8_bb_u[8];
  const mxArray *c8_fb_y = NULL;
  real_T c8_cb_u;
  const mxArray *c8_gb_y = NULL;
  real_T c8_db_u;
  const mxArray *c8_hb_y = NULL;
  real_T c8_eb_u;
  const mxArray *c8_ib_y = NULL;
  real_T c8_fb_u;
  const mxArray *c8_jb_y = NULL;
  real_T c8_gb_u;
  const mxArray *c8_kb_y = NULL;
  char_T c8_hb_u;
  const mxArray *c8_lb_y = NULL;
  int32_T c8_i10;
  char_T c8_ib_u[2];
  const mxArray *c8_mb_y = NULL;
  int32_T c8_i11;
  real_T c8_jb_u[2];
  const mxArray *c8_nb_y = NULL;
  real_T c8_kb_u[2];
  const mxArray *c8_ob_y = NULL;
  char_T c8_lb_u;
  const mxArray *c8_pb_y = NULL;
  real_T c8_c_b;
  real_T c8_qb_y;
  real_T c8_mb_u[2];
  const mxArray *c8_rb_y = NULL;
  int32_T c8_i12;
  char_T c8_nb_u[3];
  const mxArray *c8_sb_y = NULL;
  int32_T c8_i13;
  static char_T c8_cv5[3] = { 'E', 'M', 'G' };

  char_T c8_ob_u[3];
  const mxArray *c8_tb_y = NULL;
  int32_T c8_i14;
  char_T c8_pb_u[8];
  const mxArray *c8_ub_y = NULL;
  real_T c8_qb_u;
  const mxArray *c8_vb_y = NULL;
  real_T c8_b_A;
  real_T c8_b_B;
  real_T c8_c_x;
  real_T c8_wb_y;
  real_T c8_d_x;
  real_T c8_xb_y;
  real_T c8_yb_y;
  real_T c8_a;
  real_T c8_ac_y;
  real_T c8_e_x;
  real_T c8_f_x;
  real_T c8_c_A;
  real_T c8_c_B;
  real_T c8_g_x;
  real_T c8_bc_y;
  real_T c8_h_x;
  real_T c8_cc_y;
  real_T c8_dc_y;
  real_T c8_b_a;
  real_T c8_ec_y;
  real_T c8_i_x;
  real_T c8_j_x;
  real_T c8_rb_u;
  const mxArray *c8_fc_y = NULL;
  real_T c8_sb_u;
  const mxArray *c8_gc_y = NULL;
  real_T c8_tb_u;
  const mxArray *c8_hc_y = NULL;
  real_T *c8_b_ThresEMG;
  real_T *c8_b_EMG;
  real_T *c8_b_WorkloadThres;
  real_T *c8_b_AlphaFz;
  real_T *c8_b_ThetaFz;
  real_T *c8_b_AlphaThres;
  real_T *c8_b_Alpha3;
  real_T *c8_b_Alpha2;
  real_T *c8_b_Alpha1;
  c8_b_ThresEMG = (real_T *)ssGetInputPortSignal(chartInstance->S, 8);
  c8_b_EMG = (real_T *)ssGetInputPortSignal(chartInstance->S, 7);
  c8_b_WorkloadThres = (real_T *)ssGetInputPortSignal(chartInstance->S, 6);
  c8_b_AlphaFz = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
  c8_b_ThetaFz = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c8_b_AlphaThres = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c8_b_Alpha3 = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c8_b_Alpha2 = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c8_b_Alpha1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 5U, chartInstance->c8_sfEvent);
  c8_hoistedGlobal = *c8_b_Alpha1;
  c8_b_hoistedGlobal = *c8_b_Alpha2;
  c8_c_hoistedGlobal = *c8_b_Alpha3;
  c8_d_hoistedGlobal = *c8_b_AlphaThres;
  c8_e_hoistedGlobal = *c8_b_ThetaFz;
  c8_f_hoistedGlobal = *c8_b_AlphaFz;
  c8_g_hoistedGlobal = *c8_b_WorkloadThres;
  c8_h_hoistedGlobal = *c8_b_EMG;
  c8_i_hoistedGlobal = *c8_b_ThresEMG;
  c8_Alpha1 = c8_hoistedGlobal;
  c8_Alpha2 = c8_b_hoistedGlobal;
  c8_Alpha3 = c8_c_hoistedGlobal;
  c8_AlphaThres = c8_d_hoistedGlobal;
  c8_ThetaFz = c8_e_hoistedGlobal;
  c8_AlphaFz = c8_f_hoistedGlobal;
  c8_WorkloadThres = c8_g_hoistedGlobal;
  c8_EMG = c8_h_hoistedGlobal;
  c8_ThresEMG = c8_i_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 16U, 16U, c8_debug_family_names,
    c8_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c8_relax, 0U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_workload, 1U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_LRelax, 2U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_LWorkload, 3U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_LEMG, 4U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_nargin, 5U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_nargout, 6U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c8_Alpha1, 7U, c8_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c8_Alpha2, 8U, c8_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c8_Alpha3, 9U, c8_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c8_AlphaThres, 10U, c8_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c8_ThetaFz, 11U, c8_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c8_AlphaFz, 12U, c8_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c8_WorkloadThres, 13U, c8_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c8_EMG, 14U, c8_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c8_ThresEMG, 15U, c8_sf_marshallOut);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 4);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 5);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 6);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 7);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 8);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 9);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 10);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 11);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 12);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 13);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 14);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 15);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 23);
  c8_relax = c8_Alpha2;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 25);
  c8_u = 1.0;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", &c8_u, 0, 0U, 0U, 0U, 0), FALSE);
  c8_b_u = 3.0;
  c8_b_y = NULL;
  sf_mex_assign(&c8_b_y, sf_mex_create("y", &c8_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  c8_c_u = 1.0;
  c8_c_y = NULL;
  sf_mex_assign(&c8_c_y, sf_mex_create("y", &c8_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("subplot", 0U, 3U, 14, c8_y, 14, c8_b_y, 14, c8_c_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 26);
  c8_d_u = c8_relax;
  c8_d_y = NULL;
  sf_mex_assign(&c8_d_y, sf_mex_create("y", &c8_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  c8_e_u = 'r';
  c8_e_y = NULL;
  sf_mex_assign(&c8_e_y, sf_mex_create("y", &c8_e_u, 10, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("bar", 0U, 2U, 14, c8_d_y, 14, c8_e_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 27);
  for (c8_i0 = 0; c8_i0 < 2; c8_i0++) {
    c8_f_u[c8_i0] = c8_cv0[c8_i0];
  }

  c8_f_y = NULL;
  sf_mex_assign(&c8_f_y, sf_mex_create("y", c8_f_u, 10, 0U, 1U, 0U, 2, 1, 2),
                FALSE);
  sf_mex_call_debug("hold", 0U, 1U, 14, c8_f_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 28);
  for (c8_i1 = 0; c8_i1 < 2; c8_i1++) {
    c8_g_u[c8_i1] = 2.0 * (real_T)c8_i1;
  }

  c8_g_y = NULL;
  sf_mex_assign(&c8_g_y, sf_mex_create("y", c8_g_u, 0, 0U, 1U, 0U, 2, 1, 2),
                FALSE);
  c8_h_u[0] = c8_AlphaThres;
  c8_h_u[1] = c8_AlphaThres;
  c8_h_y = NULL;
  sf_mex_assign(&c8_h_y, sf_mex_create("y", c8_h_u, 0, 0U, 1U, 0U, 2, 1, 2),
                FALSE);
  c8_i_u = 'k';
  c8_i_y = NULL;
  sf_mex_assign(&c8_i_y, sf_mex_create("y", &c8_i_u, 10, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("plot", 0U, 3U, 14, c8_g_y, 14, c8_h_y, 14, c8_i_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 29);
  c8_b = c8_AlphaThres;
  c8_j_y = 1.5 * c8_b;
  c8_j_u[0] = 0.0;
  c8_j_u[1] = c8_j_y;
  c8_k_y = NULL;
  sf_mex_assign(&c8_k_y, sf_mex_create("y", c8_j_u, 0, 0U, 1U, 0U, 2, 1, 2),
                FALSE);
  sf_mex_call_debug("ylim", 0U, 1U, 14, c8_k_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 31);
  for (c8_i2 = 0; c8_i2 < 3; c8_i2++) {
    c8_k_u[c8_i2] = c8_cv1[c8_i2];
  }

  c8_l_y = NULL;
  sf_mex_assign(&c8_l_y, sf_mex_create("y", c8_k_u, 10, 0U, 1U, 0U, 2, 1, 3),
                FALSE);
  sf_mex_call_debug("hold", 0U, 1U, 14, c8_l_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 32);
  for (c8_i3 = 0; c8_i3 < 10; c8_i3++) {
    c8_l_u[c8_i3] = c8_cv2[c8_i3];
  }

  c8_m_y = NULL;
  sf_mex_assign(&c8_m_y, sf_mex_create("y", c8_l_u, 10, 0U, 1U, 0U, 2, 1, 10),
                FALSE);
  for (c8_i4 = 0; c8_i4 < 8; c8_i4++) {
    c8_m_u[c8_i4] = c8_cv3[c8_i4];
  }

  c8_n_y = NULL;
  sf_mex_assign(&c8_n_y, sf_mex_create("y", c8_m_u, 10, 0U, 1U, 0U, 2, 1, 8),
                FALSE);
  c8_n_u = 14.0;
  c8_o_y = NULL;
  sf_mex_assign(&c8_o_y, sf_mex_create("y", &c8_n_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("title", 0U, 3U, 14, c8_m_y, 14, c8_n_y, 14, c8_o_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 36);
  c8_A = c8_ThetaFz;
  c8_B = c8_AlphaFz;
  c8_x = c8_A;
  c8_p_y = c8_B;
  c8_b_x = c8_x;
  c8_q_y = c8_p_y;
  c8_workload = c8_b_x / c8_q_y;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 38);
  c8_o_u = 1.0;
  c8_r_y = NULL;
  sf_mex_assign(&c8_r_y, sf_mex_create("y", &c8_o_u, 0, 0U, 0U, 0U, 0), FALSE);
  c8_p_u = 3.0;
  c8_s_y = NULL;
  sf_mex_assign(&c8_s_y, sf_mex_create("y", &c8_p_u, 0, 0U, 0U, 0U, 0), FALSE);
  c8_q_u = 2.0;
  c8_t_y = NULL;
  sf_mex_assign(&c8_t_y, sf_mex_create("y", &c8_q_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("subplot", 0U, 3U, 14, c8_r_y, 14, c8_s_y, 14, c8_t_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 39);
  c8_r_u = c8_workload;
  c8_u_y = NULL;
  sf_mex_assign(&c8_u_y, sf_mex_create("y", &c8_r_u, 0, 0U, 0U, 0U, 0), FALSE);
  c8_s_u = 'b';
  c8_v_y = NULL;
  sf_mex_assign(&c8_v_y, sf_mex_create("y", &c8_s_u, 10, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("bar", 0U, 2U, 14, c8_u_y, 14, c8_v_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 40);
  for (c8_i5 = 0; c8_i5 < 2; c8_i5++) {
    c8_t_u[c8_i5] = c8_cv0[c8_i5];
  }

  c8_w_y = NULL;
  sf_mex_assign(&c8_w_y, sf_mex_create("y", c8_t_u, 10, 0U, 1U, 0U, 2, 1, 2),
                FALSE);
  sf_mex_call_debug("hold", 0U, 1U, 14, c8_w_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 41);
  for (c8_i6 = 0; c8_i6 < 2; c8_i6++) {
    c8_u_u[c8_i6] = 2.0 * (real_T)c8_i6;
  }

  c8_x_y = NULL;
  sf_mex_assign(&c8_x_y, sf_mex_create("y", c8_u_u, 0, 0U, 1U, 0U, 2, 1, 2),
                FALSE);
  c8_v_u[0] = c8_WorkloadThres;
  c8_v_u[1] = c8_WorkloadThres;
  c8_y_y = NULL;
  sf_mex_assign(&c8_y_y, sf_mex_create("y", c8_v_u, 0, 0U, 1U, 0U, 2, 1, 2),
                FALSE);
  c8_w_u = 'k';
  c8_ab_y = NULL;
  sf_mex_assign(&c8_ab_y, sf_mex_create("y", &c8_w_u, 10, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("plot", 0U, 3U, 14, c8_x_y, 14, c8_y_y, 14, c8_ab_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 42);
  c8_b_b = c8_WorkloadThres;
  c8_bb_y = 1.5 * c8_b_b;
  c8_x_u[0] = 0.0;
  c8_x_u[1] = c8_bb_y;
  c8_cb_y = NULL;
  sf_mex_assign(&c8_cb_y, sf_mex_create("y", c8_x_u, 0, 0U, 1U, 0U, 2, 1, 2),
                FALSE);
  sf_mex_call_debug("ylim", 0U, 1U, 14, c8_cb_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 43);
  for (c8_i7 = 0; c8_i7 < 3; c8_i7++) {
    c8_y_u[c8_i7] = c8_cv1[c8_i7];
  }

  c8_db_y = NULL;
  sf_mex_assign(&c8_db_y, sf_mex_create("y", c8_y_u, 10, 0U, 1U, 0U, 2, 1, 3),
                FALSE);
  sf_mex_call_debug("hold", 0U, 1U, 14, c8_db_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 44);
  for (c8_i8 = 0; c8_i8 < 8; c8_i8++) {
    c8_ab_u[c8_i8] = c8_cv4[c8_i8];
  }

  c8_eb_y = NULL;
  sf_mex_assign(&c8_eb_y, sf_mex_create("y", c8_ab_u, 10, 0U, 1U, 0U, 2, 1, 8),
                FALSE);
  for (c8_i9 = 0; c8_i9 < 8; c8_i9++) {
    c8_bb_u[c8_i9] = c8_cv3[c8_i9];
  }

  c8_fb_y = NULL;
  sf_mex_assign(&c8_fb_y, sf_mex_create("y", c8_bb_u, 10, 0U, 1U, 0U, 2, 1, 8),
                FALSE);
  c8_cb_u = 14.0;
  c8_gb_y = NULL;
  sf_mex_assign(&c8_gb_y, sf_mex_create("y", &c8_cb_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("title", 0U, 3U, 14, c8_eb_y, 14, c8_fb_y, 14, c8_gb_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 48);
  c8_db_u = 1.0;
  c8_hb_y = NULL;
  sf_mex_assign(&c8_hb_y, sf_mex_create("y", &c8_db_u, 0, 0U, 0U, 0U, 0), FALSE);
  c8_eb_u = 3.0;
  c8_ib_y = NULL;
  sf_mex_assign(&c8_ib_y, sf_mex_create("y", &c8_eb_u, 0, 0U, 0U, 0U, 0), FALSE);
  c8_fb_u = 3.0;
  c8_jb_y = NULL;
  sf_mex_assign(&c8_jb_y, sf_mex_create("y", &c8_fb_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("subplot", 0U, 3U, 14, c8_hb_y, 14, c8_ib_y, 14, c8_jb_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 49);
  c8_gb_u = c8_EMG;
  c8_kb_y = NULL;
  sf_mex_assign(&c8_kb_y, sf_mex_create("y", &c8_gb_u, 0, 0U, 0U, 0U, 0), FALSE);
  c8_hb_u = 'g';
  c8_lb_y = NULL;
  sf_mex_assign(&c8_lb_y, sf_mex_create("y", &c8_hb_u, 10, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("bar", 0U, 2U, 14, c8_kb_y, 14, c8_lb_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 50);
  for (c8_i10 = 0; c8_i10 < 2; c8_i10++) {
    c8_ib_u[c8_i10] = c8_cv0[c8_i10];
  }

  c8_mb_y = NULL;
  sf_mex_assign(&c8_mb_y, sf_mex_create("y", c8_ib_u, 10, 0U, 1U, 0U, 2, 1, 2),
                FALSE);
  sf_mex_call_debug("hold", 0U, 1U, 14, c8_mb_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 51);
  for (c8_i11 = 0; c8_i11 < 2; c8_i11++) {
    c8_jb_u[c8_i11] = 2.0 * (real_T)c8_i11;
  }

  c8_nb_y = NULL;
  sf_mex_assign(&c8_nb_y, sf_mex_create("y", c8_jb_u, 0, 0U, 1U, 0U, 2, 1, 2),
                FALSE);
  c8_kb_u[0] = c8_ThresEMG;
  c8_kb_u[1] = c8_ThresEMG;
  c8_ob_y = NULL;
  sf_mex_assign(&c8_ob_y, sf_mex_create("y", c8_kb_u, 0, 0U, 1U, 0U, 2, 1, 2),
                FALSE);
  c8_lb_u = 'k';
  c8_pb_y = NULL;
  sf_mex_assign(&c8_pb_y, sf_mex_create("y", &c8_lb_u, 10, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("plot", 0U, 3U, 14, c8_nb_y, 14, c8_ob_y, 14, c8_pb_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 52);
  c8_c_b = c8_ThresEMG;
  c8_qb_y = 1.5 * c8_c_b;
  c8_mb_u[0] = 0.0;
  c8_mb_u[1] = c8_qb_y;
  c8_rb_y = NULL;
  sf_mex_assign(&c8_rb_y, sf_mex_create("y", c8_mb_u, 0, 0U, 1U, 0U, 2, 1, 2),
                FALSE);
  sf_mex_call_debug("ylim", 0U, 1U, 14, c8_rb_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 53);
  for (c8_i12 = 0; c8_i12 < 3; c8_i12++) {
    c8_nb_u[c8_i12] = c8_cv1[c8_i12];
  }

  c8_sb_y = NULL;
  sf_mex_assign(&c8_sb_y, sf_mex_create("y", c8_nb_u, 10, 0U, 1U, 0U, 2, 1, 3),
                FALSE);
  sf_mex_call_debug("hold", 0U, 1U, 14, c8_sb_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 54);
  for (c8_i13 = 0; c8_i13 < 3; c8_i13++) {
    c8_ob_u[c8_i13] = c8_cv5[c8_i13];
  }

  c8_tb_y = NULL;
  sf_mex_assign(&c8_tb_y, sf_mex_create("y", c8_ob_u, 10, 0U, 1U, 0U, 2, 1, 3),
                FALSE);
  for (c8_i14 = 0; c8_i14 < 8; c8_i14++) {
    c8_pb_u[c8_i14] = c8_cv3[c8_i14];
  }

  c8_ub_y = NULL;
  sf_mex_assign(&c8_ub_y, sf_mex_create("y", c8_pb_u, 10, 0U, 1U, 0U, 2, 1, 8),
                FALSE);
  c8_qb_u = 14.0;
  c8_vb_y = NULL;
  sf_mex_assign(&c8_vb_y, sf_mex_create("y", &c8_qb_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("title", 0U, 3U, 14, c8_tb_y, 14, c8_ub_y, 14, c8_vb_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 64);
  c8_LRelax = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 65);
  c8_LWorkload = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 66);
  c8_LEMG = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 75);
  c8_b_A = c8_relax;
  c8_b_B = c8_AlphaThres;
  c8_c_x = c8_b_A;
  c8_wb_y = c8_b_B;
  c8_d_x = c8_c_x;
  c8_xb_y = c8_wb_y;
  c8_yb_y = c8_d_x / c8_xb_y;
  c8_a = c8_yb_y;
  c8_ac_y = c8_a * 100.0;
  c8_e_x = c8_ac_y;
  c8_LRelax = c8_e_x;
  c8_f_x = c8_LRelax;
  c8_LRelax = c8_f_x;
  c8_LRelax = muDoubleScalarFloor(c8_LRelax);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 77);
  if (CV_EML_IF(0, 1, 0, c8_LRelax > 100.0)) {
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 79);
    c8_LRelax = 100.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 86);
  c8_c_A = c8_workload;
  c8_c_B = c8_WorkloadThres;
  c8_g_x = c8_c_A;
  c8_bc_y = c8_c_B;
  c8_h_x = c8_g_x;
  c8_cc_y = c8_bc_y;
  c8_dc_y = c8_h_x / c8_cc_y;
  c8_b_a = c8_dc_y;
  c8_ec_y = c8_b_a * 100.0;
  c8_i_x = c8_ec_y;
  c8_LWorkload = c8_i_x;
  c8_j_x = c8_LWorkload;
  c8_LWorkload = c8_j_x;
  c8_LWorkload = muDoubleScalarFloor(c8_LWorkload);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 88);
  if (CV_EML_IF(0, 1, 1, c8_LWorkload > 100.0)) {
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 90);
    c8_LWorkload = 100.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 98);
  if (CV_EML_IF(0, 1, 2, c8_EMG > c8_ThresEMG)) {
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 100);
    c8_LEMG = 1.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 104);
  c8_rb_u = c8_LRelax;
  c8_fc_y = NULL;
  sf_mex_assign(&c8_fc_y, sf_mex_create("y", &c8_rb_u, 0, 0U, 0U, 0U, 0), FALSE);
  c8_sb_u = c8_LWorkload;
  c8_gc_y = NULL;
  sf_mex_assign(&c8_gc_y, sf_mex_create("y", &c8_sb_u, 0, 0U, 0U, 0U, 0), FALSE);
  c8_tb_u = c8_LEMG;
  c8_hc_y = NULL;
  sf_mex_assign(&c8_hc_y, sf_mex_create("y", &c8_tb_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("SendMessage", 0U, 3U, 14, c8_fc_y, 14, c8_gc_y, 14, c8_hc_y);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, -104);
  sf_debug_symbol_scope_pop();
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 5U, chartInstance->c8_sfEvent);
}

static void initSimStructsc8_HC2_SummerSchool
  (SFc8_HC2_SummerSchoolInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c8_machineNumber, uint32_T
  c8_chartNumber)
{
}

static const mxArray *c8_sf_marshallOut(void *chartInstanceVoid, void *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  real_T c8_u;
  const mxArray *c8_y = NULL;
  SFc8_HC2_SummerSchoolInstanceStruct *chartInstance;
  chartInstance = (SFc8_HC2_SummerSchoolInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_u = *(real_T *)c8_inData;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", &c8_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static real_T c8_emlrt_marshallIn(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  real_T c8_y;
  real_T c8_d0;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_d0, 1, 0, 0U, 0, 0U, 0);
  c8_y = c8_d0;
  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void c8_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_nargout;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y;
  SFc8_HC2_SummerSchoolInstanceStruct *chartInstance;
  chartInstance = (SFc8_HC2_SummerSchoolInstanceStruct *)chartInstanceVoid;
  c8_nargout = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_nargout), &c8_thisId);
  sf_mex_destroy(&c8_nargout);
  *(real_T *)c8_outData = c8_y;
  sf_mex_destroy(&c8_mxArrayInData);
}

const mxArray *sf_c8_HC2_SummerSchool_get_eml_resolved_functions_info(void)
{
  const mxArray *c8_nameCaptureInfo;
  c8_ResolvedFunctionInfo c8_info[6];
  c8_ResolvedFunctionInfo (*c8_b_info)[6];
  const mxArray *c8_m0 = NULL;
  int32_T c8_i15;
  c8_ResolvedFunctionInfo *c8_r0;
  c8_nameCaptureInfo = NULL;
  c8_nameCaptureInfo = NULL;
  c8_b_info = (c8_ResolvedFunctionInfo (*)[6])c8_info;
  (*c8_b_info)[0].context = "";
  (*c8_b_info)[0].name = "mtimes";
  (*c8_b_info)[0].dominantType = "double";
  (*c8_b_info)[0].resolved =
    "[ILXE]/Applications/MATLAB_R2012a.app/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c8_b_info)[0].fileTimeLo = 1289519692U;
  (*c8_b_info)[0].fileTimeHi = 0U;
  (*c8_b_info)[0].mFileTimeLo = 0U;
  (*c8_b_info)[0].mFileTimeHi = 0U;
  (*c8_b_info)[1].context = "";
  (*c8_b_info)[1].name = "mrdivide";
  (*c8_b_info)[1].dominantType = "double";
  (*c8_b_info)[1].resolved =
    "[ILXE]/Applications/MATLAB_R2012a.app/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c8_b_info)[1].fileTimeLo = 1325124138U;
  (*c8_b_info)[1].fileTimeHi = 0U;
  (*c8_b_info)[1].mFileTimeLo = 1319729966U;
  (*c8_b_info)[1].mFileTimeHi = 0U;
  (*c8_b_info)[2].context =
    "[ILXE]/Applications/MATLAB_R2012a.app/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c8_b_info)[2].name = "rdivide";
  (*c8_b_info)[2].dominantType = "double";
  (*c8_b_info)[2].resolved =
    "[ILXE]/Applications/MATLAB_R2012a.app/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c8_b_info)[2].fileTimeLo = 1286818844U;
  (*c8_b_info)[2].fileTimeHi = 0U;
  (*c8_b_info)[2].mFileTimeLo = 0U;
  (*c8_b_info)[2].mFileTimeHi = 0U;
  (*c8_b_info)[3].context =
    "[ILXE]/Applications/MATLAB_R2012a.app/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c8_b_info)[3].name = "eml_div";
  (*c8_b_info)[3].dominantType = "double";
  (*c8_b_info)[3].resolved =
    "[ILXE]/Applications/MATLAB_R2012a.app/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c8_b_info)[3].fileTimeLo = 1313347810U;
  (*c8_b_info)[3].fileTimeHi = 0U;
  (*c8_b_info)[3].mFileTimeLo = 0U;
  (*c8_b_info)[3].mFileTimeHi = 0U;
  (*c8_b_info)[4].context = "";
  (*c8_b_info)[4].name = "floor";
  (*c8_b_info)[4].dominantType = "double";
  (*c8_b_info)[4].resolved =
    "[ILXE]/Applications/MATLAB_R2012a.app/toolbox/eml/lib/matlab/elfun/floor.m";
  (*c8_b_info)[4].fileTimeLo = 1286818742U;
  (*c8_b_info)[4].fileTimeHi = 0U;
  (*c8_b_info)[4].mFileTimeLo = 0U;
  (*c8_b_info)[4].mFileTimeHi = 0U;
  (*c8_b_info)[5].context =
    "[ILXE]/Applications/MATLAB_R2012a.app/toolbox/eml/lib/matlab/elfun/floor.m";
  (*c8_b_info)[5].name = "eml_scalar_floor";
  (*c8_b_info)[5].dominantType = "double";
  (*c8_b_info)[5].resolved =
    "[ILXE]/Applications/MATLAB_R2012a.app/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  (*c8_b_info)[5].fileTimeLo = 1286818726U;
  (*c8_b_info)[5].fileTimeHi = 0U;
  (*c8_b_info)[5].mFileTimeLo = 0U;
  (*c8_b_info)[5].mFileTimeHi = 0U;
  sf_mex_assign(&c8_m0, sf_mex_createstruct("nameCaptureInfo", 1, 6), FALSE);
  for (c8_i15 = 0; c8_i15 < 6; c8_i15++) {
    c8_r0 = &c8_info[c8_i15];
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c8_r0->context)), "context", "nameCaptureInfo",
                    c8_i15);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c8_r0->name)), "name", "nameCaptureInfo", c8_i15);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c8_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c8_i15);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c8_r0->resolved)), "resolved", "nameCaptureInfo",
                    c8_i15);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c8_i15);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c8_i15);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c8_i15);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c8_i15);
  }

  sf_mex_assign(&c8_nameCaptureInfo, c8_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c8_nameCaptureInfo);
  return c8_nameCaptureInfo;
}

static const mxArray *c8_b_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_u;
  const mxArray *c8_y = NULL;
  SFc8_HC2_SummerSchoolInstanceStruct *chartInstance;
  chartInstance = (SFc8_HC2_SummerSchoolInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_u = *(int32_T *)c8_inData;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", &c8_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static int32_T c8_b_emlrt_marshallIn(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  int32_T c8_y;
  int32_T c8_i16;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_i16, 1, 6, 0U, 0, 0U, 0);
  c8_y = c8_i16;
  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void c8_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_b_sfEvent;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  int32_T c8_y;
  SFc8_HC2_SummerSchoolInstanceStruct *chartInstance;
  chartInstance = (SFc8_HC2_SummerSchoolInstanceStruct *)chartInstanceVoid;
  c8_b_sfEvent = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_sfEvent),
    &c8_thisId);
  sf_mex_destroy(&c8_b_sfEvent);
  *(int32_T *)c8_outData = c8_y;
  sf_mex_destroy(&c8_mxArrayInData);
}

static uint8_T c8_c_emlrt_marshallIn(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance, const mxArray *c8_b_is_active_c8_HC2_SummerSchool, const
  char_T *c8_identifier)
{
  uint8_T c8_y;
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_d_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c8_b_is_active_c8_HC2_SummerSchool), &c8_thisId);
  sf_mex_destroy(&c8_b_is_active_c8_HC2_SummerSchool);
  return c8_y;
}

static uint8_T c8_d_emlrt_marshallIn(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  uint8_T c8_y;
  uint8_T c8_u0;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_u0, 1, 3, 0U, 0, 0U, 0);
  c8_y = c8_u0;
  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void init_dsm_address_info(SFc8_HC2_SummerSchoolInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c8_HC2_SummerSchool_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3035543996U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2113985549U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2569386846U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(947238917U);
}

mxArray *sf_c8_HC2_SummerSchool_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("dMYubD3yvu5LxrjWOj3c6E");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,9,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }

    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c8_HC2_SummerSchool(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S'type','srcId','name','auxInfo'{{M[8],M[0],T\"is_active_c8_HC2_SummerSchool\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 1, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c8_HC2_SummerSchool_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc8_HC2_SummerSchoolInstanceStruct *chartInstance;
    chartInstance = (SFc8_HC2_SummerSchoolInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_HC2_SummerSchoolMachineNumber_,
           8,
           1,
           1,
           9,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_HC2_SummerSchoolMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_HC2_SummerSchoolMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_HC2_SummerSchoolMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"Alpha1");
          _SFD_SET_DATA_PROPS(1,1,1,0,"Alpha2");
          _SFD_SET_DATA_PROPS(2,1,1,0,"Alpha3");
          _SFD_SET_DATA_PROPS(3,1,1,0,"AlphaThres");
          _SFD_SET_DATA_PROPS(4,1,1,0,"ThetaFz");
          _SFD_SET_DATA_PROPS(5,1,1,0,"AlphaFz");
          _SFD_SET_DATA_PROPS(6,1,1,0,"WorkloadThres");
          _SFD_SET_DATA_PROPS(7,1,1,0,"EMG");
          _SFD_SET_DATA_PROPS(8,1,1,0,"ThresEMG");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,3,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,2148);
        _SFD_CV_INIT_EML_IF(0,1,0,1527,1542,-1,1574);
        _SFD_CV_INIT_EML_IF(0,1,1,1676,1694,-1,1729);
        _SFD_CV_INIT_EML_IF(0,1,2,1782,1799,-1,1827);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c8_Alpha1;
          real_T *c8_Alpha2;
          real_T *c8_Alpha3;
          real_T *c8_AlphaThres;
          real_T *c8_ThetaFz;
          real_T *c8_AlphaFz;
          real_T *c8_WorkloadThres;
          real_T *c8_EMG;
          real_T *c8_ThresEMG;
          c8_ThresEMG = (real_T *)ssGetInputPortSignal(chartInstance->S, 8);
          c8_EMG = (real_T *)ssGetInputPortSignal(chartInstance->S, 7);
          c8_WorkloadThres = (real_T *)ssGetInputPortSignal(chartInstance->S, 6);
          c8_AlphaFz = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
          c8_ThetaFz = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c8_AlphaThres = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c8_Alpha3 = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c8_Alpha2 = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c8_Alpha1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c8_Alpha1);
          _SFD_SET_DATA_VALUE_PTR(1U, c8_Alpha2);
          _SFD_SET_DATA_VALUE_PTR(2U, c8_Alpha3);
          _SFD_SET_DATA_VALUE_PTR(3U, c8_AlphaThres);
          _SFD_SET_DATA_VALUE_PTR(4U, c8_ThetaFz);
          _SFD_SET_DATA_VALUE_PTR(5U, c8_AlphaFz);
          _SFD_SET_DATA_VALUE_PTR(6U, c8_WorkloadThres);
          _SFD_SET_DATA_VALUE_PTR(7U, c8_EMG);
          _SFD_SET_DATA_VALUE_PTR(8U, c8_ThresEMG);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_HC2_SummerSchoolMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "hK2QLTT5RFIpjl1uDWpZbB";
}

static void sf_opaque_initialize_c8_HC2_SummerSchool(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc8_HC2_SummerSchoolInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c8_HC2_SummerSchool((SFc8_HC2_SummerSchoolInstanceStruct*)
    chartInstanceVar);
  initialize_c8_HC2_SummerSchool((SFc8_HC2_SummerSchoolInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c8_HC2_SummerSchool(void *chartInstanceVar)
{
  enable_c8_HC2_SummerSchool((SFc8_HC2_SummerSchoolInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_disable_c8_HC2_SummerSchool(void *chartInstanceVar)
{
  disable_c8_HC2_SummerSchool((SFc8_HC2_SummerSchoolInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c8_HC2_SummerSchool(void *chartInstanceVar)
{
  sf_c8_HC2_SummerSchool((SFc8_HC2_SummerSchoolInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c8_HC2_SummerSchool(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c8_HC2_SummerSchool
    ((SFc8_HC2_SummerSchoolInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c8_HC2_SummerSchool();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c8_HC2_SummerSchool(SimStruct* S, const
  mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c8_HC2_SummerSchool();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c8_HC2_SummerSchool((SFc8_HC2_SummerSchoolInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c8_HC2_SummerSchool(SimStruct* S)
{
  return sf_internal_get_sim_state_c8_HC2_SummerSchool(S);
}

static void sf_opaque_set_sim_state_c8_HC2_SummerSchool(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c8_HC2_SummerSchool(S, st);
}

static void sf_opaque_terminate_c8_HC2_SummerSchool(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc8_HC2_SummerSchoolInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c8_HC2_SummerSchool((SFc8_HC2_SummerSchoolInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_HC2_SummerSchool_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc8_HC2_SummerSchool((SFc8_HC2_SummerSchoolInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c8_HC2_SummerSchool(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c8_HC2_SummerSchool((SFc8_HC2_SummerSchoolInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c8_HC2_SummerSchool(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_HC2_SummerSchool_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      8);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,8,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,8,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 7, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 8, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,8,9);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,8);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(3021283568U));
  ssSetChecksum1(S,(3321098459U));
  ssSetChecksum2(S,(2703427605U));
  ssSetChecksum3(S,(1346819497U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c8_HC2_SummerSchool(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c8_HC2_SummerSchool(SimStruct *S)
{
  SFc8_HC2_SummerSchoolInstanceStruct *chartInstance;
  chartInstance = (SFc8_HC2_SummerSchoolInstanceStruct *)malloc(sizeof
    (SFc8_HC2_SummerSchoolInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc8_HC2_SummerSchoolInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c8_HC2_SummerSchool;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c8_HC2_SummerSchool;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c8_HC2_SummerSchool;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c8_HC2_SummerSchool;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c8_HC2_SummerSchool;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c8_HC2_SummerSchool;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c8_HC2_SummerSchool;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c8_HC2_SummerSchool;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c8_HC2_SummerSchool;
  chartInstance->chartInfo.mdlStart = mdlStart_c8_HC2_SummerSchool;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c8_HC2_SummerSchool;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c8_HC2_SummerSchool_method_dispatcher(SimStruct *S, int_T method, void
  *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c8_HC2_SummerSchool(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c8_HC2_SummerSchool(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c8_HC2_SummerSchool(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c8_HC2_SummerSchool_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
