/* Include files */

#include "hive_sfun.h"
#include "c14_hive.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "hive_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c14_IN_NO_ACTIVE_CHILD         (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc14_hiveInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c14_hive(void);
static void initialize_params_c14_hive(void);
static void enable_c14_hive(void);
static void disable_c14_hive(void);
static void update_debugger_state_c14_hive(void);
static const mxArray *get_sim_state_c14_hive(void);
static void set_sim_state_c14_hive(const mxArray *c14_st);
static void finalize_c14_hive(void);
static void sf_c14_hive(void);
static void c14_c14_hive(void);
static void init_script_number_translation(uint32_T c14_machineNumber, uint32_T
  c14_chartNumber);
static const mxArray *c14_sf_marshall(void *c14_chartInstance, void *c14_u);
static const mxArray *c14_b_sf_marshall(void *c14_chartInstance, void *c14_u);
static const mxArray *c14_c_sf_marshall(void *c14_chartInstance, void *c14_u);
static void c14_info_helper(c14_ResolvedFunctionInfo c14_info[18]);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c14_hive(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c14_is_active_c14_hive = 0U;
}

static void initialize_params_c14_hive(void)
{
}

static void enable_c14_hive(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c14_hive(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void update_debugger_state_c14_hive(void)
{
}

static const mxArray *get_sim_state_c14_hive(void)
{
  return NULL;
}

static void set_sim_state_c14_hive(const mxArray *c14_st)
{
  sf_mex_destroy(&c14_st);
}

static void finalize_c14_hive(void)
{
}

static void sf_c14_hive(void)
{
  int32_T c14_i0;
  uint8_T c14_previousEvent;
  real_T (*c14_in)[5000];
  c14_in = (real_T (*)[5000])ssGetInputPortSignal(chartInstance.S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,0);
  for (c14_i0 = 0; c14_i0 < 5000; c14_i0 = c14_i0 + 1) {
    _SFD_DATA_RANGE_CHECK((*c14_in)[c14_i0], 0U);
  }

  c14_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  c14_c14_hive();
  _sfEvent_ = c14_previousEvent;
  sf_debug_check_for_state_inconsistency(_hiveMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void c14_c14_hive(void)
{
  int32_T c14_i1;
  real_T c14_in[5000];
  real_T c14_nargout = 0.0;
  real_T c14_nargin = 1.0;
  const mxArray *c14_threshold = NULL;
  const mxArray *c14_in2 = NULL;
  const mxArray *c14_b = NULL;
  real_T c14_N;
  real_T c14_fc2;
  real_T c14_fs;
  real_T c14_u;
  const mxArray *c14_y = NULL;
  real_T c14_b_u;
  const mxArray *c14_b_y = NULL;
  int32_T c14_i2;
  static char_T c14_cv0[3] = { 'l', 'o', 'w' };

  char_T c14_c_u[3];
  const mxArray *c14_c_y = NULL;
  real_T c14_d_u;
  const mxArray *c14_d_y = NULL;
  int32_T c14_i3;
  real_T c14_e_u[5000];
  const mxArray *c14_e_y = NULL;
  const mxArray *c14_filter;
  real_T c14_dv0[5000];
  int32_T c14_i4;
  int32_T c14_i5;
  real_T c14_f_u[4501];
  const mxArray *c14_f_y = NULL;
  real_T (*c14_b_in)[5000];
  c14_b_in = (real_T (*)[5000])ssGetInputPortSignal(chartInstance.S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,0);
  for (c14_i1 = 0; c14_i1 < 5000; c14_i1 = c14_i1 + 1) {
    c14_in[c14_i1] = (*c14_b_in)[c14_i1];
  }

  sf_debug_symbol_scope_push(9U, 0U);
  sf_debug_symbol_scope_add("nargout", &c14_nargout, c14_b_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c14_nargin, c14_b_sf_marshall);
  sf_debug_symbol_scope_add("threshold", &c14_threshold, c14_c_sf_marshall);
  sf_debug_symbol_scope_add("in2", &c14_in2, c14_c_sf_marshall);
  sf_debug_symbol_scope_add("b", &c14_b, c14_c_sf_marshall);
  sf_debug_symbol_scope_add("N", &c14_N, c14_b_sf_marshall);
  sf_debug_symbol_scope_add("fc2", &c14_fc2, c14_b_sf_marshall);
  sf_debug_symbol_scope_add("fs", &c14_fs, c14_b_sf_marshall);
  sf_debug_symbol_scope_add("in", &c14_in, c14_sf_marshall);
  CV_EML_FCN(0, 0);

  /*  This block supports the Embedded MATLAB subset. */
  /*  See the help menu for details.  */
  /* eml.extrinsic('ParseActiViewData'); */
  /* eml.extrinsic('ParseDataTrigguer'); */
  /* eml.extrinsic('tic'); */
  _SFD_EML_CALL(0,7);
  _SFD_EML_CALL(0,8);
  _SFD_EML_CALL(0,9);
  _SFD_EML_CALL(0,10);
  _SFD_EML_CALL(0,11);
  _SFD_EML_CALL(0,12);
  _SFD_EML_CALL(0,13);
  _SFD_EML_CALL(0,14);

  /* %  FILTER DESIGN   %% */
  /* %Sampling Frequency */
  _SFD_EML_CALL(0,18);
  c14_fs = 500.0;
  _SFD_EML_CALL(0,19);
  c14_fc2 = 35.0;

  /* %Filter type */
  _SFD_EML_CALL(0,21);
  c14_N = 250.0;

  /* %Butterworth filter designe */
  _SFD_EML_CALL(0,24);
  c14_u = c14_N;
  c14_y = NULL;
  sf_mex_assign(&c14_y, sf_mex_create("y", &c14_u, 0, 0U, 0U, 0U, 0));
  c14_b_u = 0.14;
  c14_b_y = NULL;
  sf_mex_assign(&c14_b_y, sf_mex_create("y", &c14_b_u, 0, 0U, 0U, 0U, 0));
  for (c14_i2 = 0; c14_i2 < 3; c14_i2 = c14_i2 + 1) {
    c14_c_u[c14_i2] = c14_cv0[c14_i2];
  }

  c14_c_y = NULL;
  sf_mex_assign(&c14_c_y, sf_mex_create("y", &c14_c_u, 10, 0U, 1U, 0U, 2, 1, 3));
  sf_mex_assign(&c14_b, sf_mex_call("fir1", 1U, 3U, 14, c14_y, 14, c14_b_y, 14,
    c14_c_y));
  _SFD_EML_CALL(0,25);
  c14_d_u = 1.0;
  c14_d_y = NULL;
  sf_mex_assign(&c14_d_y, sf_mex_create("y", &c14_d_u, 0, 0U, 0U, 0U, 0));
  for (c14_i3 = 0; c14_i3 < 5000; c14_i3 = c14_i3 + 1) {
    c14_e_u[c14_i3] = c14_in[c14_i3];
  }

  c14_e_y = NULL;
  sf_mex_assign(&c14_e_y, sf_mex_create("y", &c14_e_u, 0, 0U, 1U, 0U, 1, 5000));
  c14_filter = sf_mex_call("filter", 1U, 3U, 14, sf_mex_dup(c14_b), 14, c14_d_y,
    14, c14_e_y);
  sf_mex_import("filter", sf_mex_dup(c14_filter), &c14_dv0, 1, 0, 0U, 1, 0U, 1,
                5000);
  for (c14_i4 = 0; c14_i4 < 5000; c14_i4 = c14_i4 + 1) {
    c14_in[c14_i4] = c14_dv0[c14_i4];
  }

  sf_mex_destroy(&c14_filter);

  /* % Avoid the first second due to filter  */
  _SFD_EML_CALL(0,27);
  for (c14_i5 = 0; c14_i5 < 4501; c14_i5 = c14_i5 + 1) {
    c14_f_u[c14_i5] = c14_in[499 + c14_i5];
  }

  c14_f_y = NULL;
  sf_mex_assign(&c14_f_y, sf_mex_create("y", &c14_f_u, 0, 0U, 1U, 0U, 1, 4501));
  sf_mex_assign(&c14_in2, sf_mex_call("detrend", 1U, 1U, 14, c14_f_y));
  _SFD_EML_CALL(0,29);
  sf_mex_assign(&c14_threshold, sf_mex_call("mean", 1U, 1U, 14, sf_mex_dup
    (c14_in2)));
  _SFD_EML_CALL(0,30);
  sf_mex_call("plot", 0U, 1U, 14, sf_mex_dup(c14_in2));

  /* hold('on'); */
  /* plot([0 length(in2)], [threshold threshold], '-r'); */
  /* hold('off'); */
  /* hold off; */
  _SFD_EML_CALL(0,-30);
  sf_debug_symbol_scope_pop();
  sf_mex_destroy(&c14_b);
  sf_mex_destroy(&c14_in2);
  sf_mex_destroy(&c14_threshold);
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,0);
}

static void init_script_number_translation(uint32_T c14_machineNumber, uint32_T
  c14_chartNumber)
{
}

static const mxArray *c14_sf_marshall(void *c14_chartInstance, void *c14_u)
{
  const mxArray *c14_y = NULL;
  int32_T c14_i6;
  real_T c14_b_u[5000];
  const mxArray *c14_b_y = NULL;
  c14_y = NULL;
  for (c14_i6 = 0; c14_i6 < 5000; c14_i6 = c14_i6 + 1) {
    c14_b_u[c14_i6] = (*((real_T (*)[5000])c14_u))[c14_i6];
  }

  c14_b_y = NULL;
  sf_mex_assign(&c14_b_y, sf_mex_create("y", &c14_b_u, 0, 0U, 1U, 0U, 1, 5000));
  sf_mex_assign(&c14_y, c14_b_y);
  return c14_y;
}

static const mxArray *c14_b_sf_marshall(void *c14_chartInstance, void *c14_u)
{
  const mxArray *c14_y = NULL;
  real_T c14_b_u;
  const mxArray *c14_b_y = NULL;
  c14_y = NULL;
  c14_b_u = *((real_T *)c14_u);
  c14_b_y = NULL;
  sf_mex_assign(&c14_b_y, sf_mex_create("y", &c14_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c14_y, c14_b_y);
  return c14_y;
}

static const mxArray *c14_c_sf_marshall(void *c14_chartInstance, void *c14_u)
{
  const mxArray *c14_y = NULL;
  const mxArray *c14_b_u;
  const mxArray *c14_b_y = NULL;
  c14_y = NULL;
  c14_b_u = sf_mex_dup(*((const mxArray **)c14_u));
  c14_b_y = NULL;
  sf_mex_assign(&c14_b_y, sf_mex_duplicatearraysafe(&c14_b_u));
  sf_mex_destroy(&c14_b_u);
  sf_mex_assign(&c14_y, c14_b_y);
  return c14_y;
}

const mxArray *sf_c14_hive_get_eml_resolved_functions_info(void)
{
  const mxArray *c14_nameCaptureInfo = NULL;
  c14_ResolvedFunctionInfo c14_info[18];
  const mxArray *c14_m0 = NULL;
  int32_T c14_i7;
  c14_ResolvedFunctionInfo *c14_r0;
  c14_nameCaptureInfo = NULL;
  c14_info_helper(c14_info);
  sf_mex_assign(&c14_m0, sf_mex_createstruct("nameCaptureInfo", 1, 18));
  for (c14_i7 = 0; c14_i7 < 18; c14_i7 = c14_i7 + 1) {
    c14_r0 = &c14_info[c14_i7];
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", c14_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c14_r0->context)), "context"
                    , "nameCaptureInfo", c14_i7);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", c14_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c14_r0->name)), "name",
                    "nameCaptureInfo", c14_i7);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo",
      c14_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c14_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c14_i7);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", c14_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c14_r0->resolved)),
                    "resolved", "nameCaptureInfo", c14_i7);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", &c14_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c14_i7);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", &c14_r0->fileTime1,
      7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c14_i7);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", &c14_r0->fileTime2,
      7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c14_i7);
  }

  sf_mex_assign(&c14_nameCaptureInfo, c14_m0);
  return c14_nameCaptureInfo;
}

static void c14_info_helper(c14_ResolvedFunctionInfo c14_info[18])
{
  c14_info[0].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c14_info[0].name = "size";
  c14_info[0].dominantType = "double";
  c14_info[0].resolved = "[B]size";
  c14_info[0].fileLength = 0U;
  c14_info[0].fileTime1 = 0U;
  c14_info[0].fileTime2 = 0U;
  c14_info[1].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c14_info[1].name = "eml_div";
  c14_info[1].dominantType = "double";
  c14_info[1].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c14_info[1].fileLength = 4254U;
  c14_info[1].fileTime1 = 1192466772U;
  c14_info[1].fileTime2 = 0U;
  c14_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c14_info[2].name = "isscalar";
  c14_info[2].dominantType = "double";
  c14_info[2].resolved = "[B]isscalar";
  c14_info[2].fileLength = 0U;
  c14_info[2].fileTime1 = 0U;
  c14_info[2].fileTime2 = 0U;
  c14_info[3].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c14_info[3].name = "rdivide";
  c14_info[3].dominantType = "double";
  c14_info[3].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c14_info[3].fileLength = 620U;
  c14_info[3].fileTime1 = 1213637690U;
  c14_info[3].fileTime2 = 0U;
  c14_info[4].context = "";
  c14_info[4].name = "mtimes";
  c14_info[4].dominantType = "double";
  c14_info[4].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c14_info[4].fileLength = 2336U;
  c14_info[4].fileTime1 = 1213637690U;
  c14_info[4].fileTime2 = 0U;
  c14_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c14_info[5].name = "strcmp";
  c14_info[5].dominantType = "char";
  c14_info[5].resolved = "[B]strcmp";
  c14_info[5].fileLength = 0U;
  c14_info[5].fileTime1 = 0U;
  c14_info[5].fileTime2 = 0U;
  c14_info[6].context = "";
  c14_info[6].name = "mrdivide";
  c14_info[6].dominantType = "double";
  c14_info[6].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c14_info[6].fileLength = 755U;
  c14_info[6].fileTime1 = 1209330882U;
  c14_info[6].fileTime2 = 0U;
  c14_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c14_info[7].name = "isempty";
  c14_info[7].dominantType = "double";
  c14_info[7].resolved = "[B]isempty";
  c14_info[7].fileLength = 0U;
  c14_info[7].fileTime1 = 0U;
  c14_info[7].fileTime2 = 0U;
  c14_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c14_info[8].name = "gt";
  c14_info[8].dominantType = "double";
  c14_info[8].resolved = "[B]gt";
  c14_info[8].fileLength = 0U;
  c14_info[8].fileTime1 = 0U;
  c14_info[8].fileTime2 = 0U;
  c14_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c14_info[9].name = "nargin";
  c14_info[9].dominantType = "";
  c14_info[9].resolved = "[B]nargin";
  c14_info[9].fileLength = 0U;
  c14_info[9].fileTime1 = 0U;
  c14_info[9].fileTime2 = 0U;
  c14_info[10].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c14_info[10].name = "isa";
  c14_info[10].dominantType = "double";
  c14_info[10].resolved = "[B]isa";
  c14_info[10].fileLength = 0U;
  c14_info[10].fileTime1 = 0U;
  c14_info[10].fileTime2 = 0U;
  c14_info[11].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c14_info[11].name = "isinteger";
  c14_info[11].dominantType = "double";
  c14_info[11].resolved = "[B]isinteger";
  c14_info[11].fileLength = 0U;
  c14_info[11].fileTime1 = 0U;
  c14_info[11].fileTime2 = 0U;
  c14_info[12].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c14_info[12].name = "eml_warning";
  c14_info[12].dominantType = "char";
  c14_info[12].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c14_info[12].fileLength = 262U;
  c14_info[12].fileTime1 = 1213637688U;
  c14_info[12].fileTime2 = 0U;
  c14_info[13].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c14_info[13].name = "eq";
  c14_info[13].dominantType = "double";
  c14_info[13].resolved = "[B]eq";
  c14_info[13].fileLength = 0U;
  c14_info[13].fileTime1 = 0U;
  c14_info[13].fileTime2 = 0U;
  c14_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c14_info[14].name = "class";
  c14_info[14].dominantType = "double";
  c14_info[14].resolved = "[B]class";
  c14_info[14].fileLength = 0U;
  c14_info[14].fileTime1 = 0U;
  c14_info[14].fileTime2 = 0U;
  c14_info[15].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m/eml_fldiv";
  c14_info[15].name = "isreal";
  c14_info[15].dominantType = "double";
  c14_info[15].resolved = "[B]isreal";
  c14_info[15].fileLength = 0U;
  c14_info[15].fileTime1 = 0U;
  c14_info[15].fileTime2 = 0U;
  c14_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c14_info[16].name = "not";
  c14_info[16].dominantType = "logical";
  c14_info[16].resolved = "[B]not";
  c14_info[16].fileLength = 0U;
  c14_info[16].fileTime1 = 0U;
  c14_info[16].fileTime2 = 0U;
  c14_info[17].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c14_info[17].name = "ge";
  c14_info[17].dominantType = "double";
  c14_info[17].resolved = "[B]ge";
  c14_info[17].fileLength = 0U;
  c14_info[17].fileTime1 = 0U;
  c14_info[17].fileTime2 = 0U;
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c14_hive_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(503804302U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(344857787U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2967918319U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2566694644U);
}

mxArray *sf_c14_hive_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1204314747U);
    pr[1] = (double)(4274008423U);
    pr[2] = (double)(3532626307U);
    pr[3] = (double)(1027716228U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(5000);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
    /* do this only if simulation is starting */
    if (!sim_mode_is_rtw_gen(S)) {
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_hiveMachineNumber_,
          14,
          1,
          1,
          1,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_hiveMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_hiveMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_hiveMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[2];
            dimVector[0]= 5000;
            dimVector[1]= 1;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"in",0,c14_sf_marshall);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,755);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c14_in)[5000];
          c14_in = (real_T (*)[5000])ssGetInputPortSignal(chartInstance.S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c14_in);
        }
      }
    }
  } else {
    sf_debug_reset_current_state_configuration(_hiveMachineNumber_,
      chartInstance.chartNumber,chartInstance.instanceNumber);
  }
}

static void sf_opaque_initialize_c14_hive(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c14_hive();
  initialize_c14_hive();
}

static void sf_opaque_enable_c14_hive(void *chartInstanceVar)
{
  enable_c14_hive();
}

static void sf_opaque_disable_c14_hive(void *chartInstanceVar)
{
  disable_c14_hive();
}

static void sf_opaque_gateway_c14_hive(void *chartInstanceVar)
{
  sf_c14_hive();
}

static mxArray* sf_opaque_get_sim_state_c14_hive(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c14_hive();
  return st;
}

static void sf_opaque_set_sim_state_c14_hive(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c14_hive(sf_mex_dup(st));
}

static void sf_opaque_terminate_c14_hive(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c14_hive();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c14_hive(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c14_hive();
  }
}

static void mdlSetWorkWidths_c14_hive(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("hive","hive",14);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("hive","hive",14,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("hive","hive",14,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"hive","hive",14,1);
    }

    sf_set_rtw_dwork_info(S,"hive","hive",14);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2705525239U));
  ssSetChecksum1(S,(1550605832U));
  ssSetChecksum2(S,(277131802U));
  ssSetChecksum3(S,(92824300U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c14_hive(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "hive", "hive",14);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c14_hive(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c14_hive;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c14_hive;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c14_hive;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c14_hive;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c14_hive;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c14_hive;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c14_hive;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c14_hive;
  chartInstance.chartInfo.mdlStart = mdlStart_c14_hive;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c14_hive;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c14_hive_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c14_hive(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c14_hive(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c14_hive(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c14_hive_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
