

import javax.sound.midi.*
scale = [60 62 64 65 67 69 71 72];

info = MidiSystem.getMidiDeviceInfo;	 % This will return a list of available MIDI devices 

outputPort = MidiSystem.getMidiDevice(info(1));	 % The actual device index will vary depending on your configuration

outputPort.open;
r = outputPort.getReceiver;
note1 = ShortMessage;
note2 = ShortMessage;


for i=1:length(scale)-1
    
	note1.setMessage(ShortMessage.NOTE_ON, 1, scale(i), 127)
    tic
    r.send(note1, -1)
    toc
    note2.setMessage(ShortMessage.NOTE_ON, 1, scale(i+1), 127)
    r.send(note2, -1)
    pause(0.5);
    note1.setMessage(ShortMessage.NOTE_OFF, 1, scale(i), 127);
	r.send(note1, -1)
    note2.setMessage(ShortMessage.NOTE_OFF, 1, scale(i+1), 127);
	r.send(note2, -1)
    
% 	pause(0.5);
end

outputPort.close;